#include <linux/module.h>

//////////////////////////////////////////////////////////////////////
// Debug output
//////////////////////////////////////////////////////////////////////
#define U50_LOG 0
#if U50_LOG
#define LDDebugOut(format,arg...) vprintk(format, ##arg)
#else
#define LDDebugOut(format,arg...)
#endif

void LDDebugError(char* szFormat, ... )
{
#if U50_LOG
	va_list marker;
	va_start(marker, szFormat);
	LDDebugOut(szFormat, marker);
	va_end(marker);
#endif
}

void LDDebugInform(char* szFormat, ... )
{
#if U50_LOG
	va_list marker;
	va_start(marker, szFormat);
	LDDebugOut(szFormat, marker);
	va_end(marker);
#endif
}

const char *prefix = "U50: ";
void LDDebugTracePacket(char* szType, uint8_t *mp, int length)
{
#if U50_LOG
	print_hex_dump_bytes(szType, DUMP_PREFIX_OFFSET, mp, length);
#endif
}
