#include "U50Link.h"
#include "CCritical.h"

//////////////////////////////////////////////////////////////////////
// Per-device U50/LTA object.
// Includes worker threads, and is one per COM(n) port.
//////////////////////////////////////////////////////////////////////
class CU50Devices : public CCritical
{
public:
	// Constructo / Destructo
	CU50Devices();
	virtual ~CU50Devices();
	// Access methods
	short Open(U50OpenMode mode);
	short Close(void);
	short Read(pLDV_Message pMsg, int iSize);
	short Write(const pLDV_Message pMsg);
	short RegisterEvent(OsalHandle hClientEvent);
    short SetClientHwnd(HWND hWnd, WPARAM wParam, LPARAM lParam);
	int GetStats(pU50_Stats ps);
/*
	short Identify(void);
*/
    DWORD           m_DevIndex;     // [0] based device instance
    PORT_HANDLE		m_hComPort;
	BOOL			bIsOpen;		// indicates <m_iOpenReferences> is >0.
	const char*    	m_sComPort;
	DWORD			m_baudrate;
private:
	int				m_iOpenReferences;
	struct U50LinkState m_linkState;
};

