/////////////////////////////////////////////////////////////////////////////

//

// $Header: //depot/Software/IotRouter/dev/U50Module/include/EchCompat.h#1 $

//

// Copyright (C) 2006 - 2013 Echelon Corporation.  All rights reserved.

//

// Use of this code is subject to the terms of the Echelon Example Software License

// Agreement which is available at www.echelon.com/license/examplesoftware/.

//

// Standard C Function Compatibility Map

//

/////////////////////////////////////////////////////////////////////////////

#ifdef SUPPORT_PRAGMA_ONCE

#pragma once

#endif



#ifndef __EchCompat_h

#define __EchCompat_h



#include "EchelonStandardDefinitions.h"



#ifdef _MSC_VER

	// Microsoft renamed all runtime functions to have a "-" prefix,

	// reportedly for ISO C++ conformance

	#define	strnicmp		_strnicmp	

	#define	chmod			_chmod	

	#define	fileno			_fileno	

//	#define	close			_close	

	#define	read			_read	

	#define	write			_write

	#define	lseek			_lseek

	#define	strdup			_strdup

	#define	stricmp			_stricmp

	#define	snprintf		_snprintf

	#define vsnprintf		_vsnprintf



#elif defined(__VXWORKS__)

	#define stricmp			_stricmp

	#define strnicmp		_strnicmp



#else	// GCC (is there a symbol?) has its own names for case-sensitive strcmp

	#define stricmp			strcasecmp

	#define strnicmp		strncasecmp

#endif





#endif		// __EchCompat_h

