//////////////////////////////////////////////////////////////////////////////

//

// Max.h

//

// Copyright (C) 2010 - 2013 Echelon Corporation.  All rights reserved.

//

// Use of this code is subject to the terms of the Echelon Example Software License

// Agreement which is available at www.echelon.com/license/examplesoftware/.

//

// Echelon MAX Top-Level Include File

//

// This file must be included after other include files that declare

// the platform (Windows, etc.)

/////////////////////////////////////////////////////////////////////////////



#ifndef MAX_H

#define MAX_H



// Linux definitions here

#include <unistd.h>

#include <time.h>

#include <errno.h>

#include <termios.h>

#include <fcntl.h>

#include <pthread.h>

#include <stdlib.h>

#include <stdio.h>

#include <stdarg.h>

#include <string.h>

#include <stdint.h>

#include <ctype.h>

#ifndef WIN32

	#include <sys/syslog.h>

#endif



#include "echstd.h"

#include "ech_logger.h"

#include "Osal.h"



// We don't actually have DcxErrors or LDVCode so map to EchErr for the time being

#define DcxError EchErr

#define LDVCode EchErr



// Essentially extensions to string.h

void safe_strncpy(char *target, const char *source, size_t maxLength);

void safe_strncat(char *target, const char *source, size_t maxLength);





// Following are not defined in linux headers, Need to decide how we will resolve them.

C_API_START

#		ifndef _INC_MINMAX

#			define _INC_MINMAX



#			ifndef MAX

#				define MAX(a,b)            (((a) > (b)) ? (a) : (b))

#			endif



#			ifndef MIN

#				define MIN(a,b)            (((a) < (b)) ? (a) : (b))

#			endif

#		endif



		clock_t msec_clock();	// millisecond version of clock()



		const char *strsigname(int signum);

C_API_END



void		OsPrintError(long osError, const char *szContext);



#include "EchCompat.h"



#if defined(WIN32) || defined(TARGET_PLATFORM)

	#define DISCARD			1 ? (void)0 : printf

	#define DISCARD_ARGS	DISCARD

#else

	#define TRACE			printf

	#define DISCARD(...)

	#define DISCARD_ARGS(...)

#endif



#define SZ_DEFAULT_LON 		"/dev/abandplc"	// smp

#define DCMP_NEURON_CHANNEL 0



#endif		// MAX_H

