//

// echstd.h

//

// Copyright (C) 2003 - 2013 Echelon Corporation.  All rights reserved.

//

// Use of this code is subject to the terms of the Echelon Example Software License

// Agreement which is available at www.echelon.com/license/examplesoftware/.

//

// This file contains standard definitions used in Echelon

// C++ projects.  

//

// $Header: //depot/Software/IotRouter/dev/U50Module/include/echstd.h#1 $

//



#ifndef ECHSTD_H

#define ECHSTD_H



#include "BuildOptions.h"



// Do not include in Neuron C.

#ifndef _ECHELON



//

//	Override VC default warnings at level 3

//



#ifdef _MSC_VER

#pragma warning(disable:4244)	// 'argument' : conversion from 'type1' to 'type2', possible loss of data

#ifdef STRICTER_WARNINGS

//#pragma warning (3:	4100)	// unreferenced formal parameter (normally level 4)

#pragma warning (3:		4189)	// local variable is initialized but not referenced (normally level 4)

#pragma warning (3:		4701)	// potentially uninitialized local variable used (normally level 4)

#pragma warning (3:		4706)	// assignment within conditional expression (normally level 4)

#endif	// STRICTER_WARNINGS

#endif	// _MSC_VER



//

// Define means by which unused parameter warnings can be suppressed.

//

#ifdef _MSC_VER

#define WARNING_PUSH                warning (push)

#define WARNING_OFF_UNUSED_PARAM    warning (disable : 4100)

#define WARNING_OFF_INT_TO_BOOL     warning (disable : 4800)

#define WARNING_POP                 warning (pop)

#else

#define WARNING_PUSH

#define WARNING_OFF_UNUSED_PARAM

#define WARNING_OFF_INT_TO_BOOL

#define WARNING_POP

#endif



//

// Macros to suppress warnings for unused parameters

//

#ifdef _DEBUG

#define UNUSED_REL(x)

#else

#define UNUSED_REL(x) x

#endif



#ifdef _MSC_VER

#define UNUSED_ALWAYS(x) x

#else

#define UNUSED_ALWAYS(x)

#endif



// Packing control directives

#define _DCX_PACKING	1	// (not used anymore because gcc does not support symbolic pack() argument

// The AVOID_PACKING macro must always be defined, to make sure packing is avoided when necessary.

// It must be used only as #if !AVOID_PACKING, not #ifndef AVOID_PACKING or similar

#if DCXGEN >= 3

#define AVOID_PACKING 1	// Don't pack

#else

#define AVOID_PACKING 0 // Do pack

#endif





//

// The following are the standard definitions to be used by 

// Echelon products.  The definitions in EchelonStandardDefinitions.h

// are expected to be reasonable to export with API products.  Those

// that are not should be included in this file directly.

//

#include "EchelonStandardDefinitions.h"



#include "reminder.h"



// Bring in the standard platform definitions

#include "nsplatform.h"



#endif	// !_ECHELON



#endif

