//

// reminder.h

//

// Copyright (C) 2003 - 2013 Echelon Corporation.  All rights reserved.

//

// Use of this code is subject to the terms of the Echelon Example Software License

// Agreement which is available at www.echelon.com/license/examplesoftware/.

//

#if 0

  // These are not comments so they don't show up in the Tasks list in Eclipse.

   This file contains definition for the REMINDER and NOTE macros.

#endif

//

// $Header: //depot/Software/IotRouter/dev/U50Module/include/reminder.h#1 $



#ifdef SUPPORT_PRAGMA_ONCE

#pragma once

#endif



#ifndef __reminder_h

#define __reminder_h





// Compile-time reminder macro.

// Formed like other VC compiler messages -- double click to 

// jump to the source location.

#if 0

   // These are not comments so they don't show up in the Tasks list in Eclipse.

   Usage: REMINDER("Some message")

  		use it to tag an issue to be addressed later

   Usage: NOTE("Some message")

  		use it to highlight some characteristic about the build

#endif

#define _QUOTE(x) # x

#define QUOTE(x) _QUOTE(x)

#define __FILE__LINE__ __FILE__ "(" QUOTE(__LINE__) ") : "

#define _REMINDER_ __FILE__LINE__ "Reminder: "

#define _NOTE_ __FILE__LINE__ "Note: "



#ifdef NO_REMINDERS

#define REMINDER(text)

#define NOTE(text)

#else

#define REMINDER(text) message (_REMINDER_ #text)

#define NOTE(text) message (_NOTE_ #text)

#endif



// this is useful for tracing the path of execution in the target;

// it is enabled only when "pcons" is enabled.

#define CHECKPOINT ConPrintf("Debug checkpoint hit at %s\n", __FILE__LINE__)



#endif		// __reminder_h

